var pdf=false;
var slinkiShowSplashDuration=3000;
var screencss="";
var pdfcss="";

function boot(){
	if(slinki.error)
	{	alert("Problem parsing {slinki} JSON\n"+slinki.json);
	}
	setTitle();
	setCopyright();
	setFavicon();
	setScripts();
	setCSS();
	
	//var splash=$("#splash").detach();
	
	//Remove vertical slides as not supported in this framework
	//$(".vslide").remove();

	//To work round browser bug find articles that have gone into the DOM and been unwrapped from their <slide> parent
	$("slide").filter(function(){
		return $(this).find("article").size()==0;	//Find slides with no <article> inside
	}).each(function(){
		var s=$(this)
		var a=s.parent().next("article");	//Step up to parent (for some reason browser puts them in a <p> block) then find the lost <article>.
		if(a!=null)
		{	s.append(a.detach());	//Put it back where it came from!
		}
		else
		{	//We can't find the article so delete the empty slide ;-(
			s.detach();
		}
	})
	;
	//In case we missed any look for unwrapped <article> and wrap then in <slide>
	$("article").filter(function(){
		var p=$(this).parent()[0];
		return p.nodeName!="SLIDE";
	}).wrap("<slide> </slide>")
		
	//Now take care of all well structured slides
	var slides=$("slide").detach();
	//alert(slides[0])
	$("body").children().remove();
		
	//Put the slides back
	$("body").append("<slides class='layout-widescreen' id='insertSlides'> </slides><div id='io2012Boot'> </div>");
	slides.appendTo("#insertSlides");
	
	bootIO();
	
	/*  Splash not working yet
	//Show Splash if not self referenced	
	transition=document.URL;
	if(transition.indexOf("#") < 0)
	{	//Put the splash back
		//$("body").append(splash);
		//showSplash();
	}
	*/
	
	setVertical();
	bindTogglePrintPDF();
}
function bootIO()
{	//Boot IO-2012
	$("#io2012Boot").html("<script data-main='/wink/res/io-2012/1.1.1/js/slides' src='/wink/res/io-2012/1.1.1/js/require-1.0.8.min.js'>_</script>");
}

function showSplash()
{	if(slinki.splashDuration!=null)
	{	slinkiShowSplashDuration=slinki.splashDuration;
	}
	show=$("#splash").length==1;
	if(show && slinkiShowSplashDuration>0)
	{
	 	$("#splash").css({"opacity" : 1, "display": "block", "visibility" : "visible" , "position":"fixed", "top": "25%" , "left": "25%", "width": "50%", "height":"50%" , "z-index":"1000"} ); 
	 	$("#splash").click(function()
	 		{	hideSplash(0);
	 			return false;
	 		}	
	 	);
	 	setTimeout('hideSplash(500)', slinkiShowSplashDuration);
 	}
}
 
function hideSplash(t)
{	$("#splash").fadeOut(t);
	//$("slide").css({ "opacity" : 1.0 } );
	//remove splash so it doesn't appear in printout
	$("#splash").remove();
}
 
function setVertical()
{	h=$(window).height();
	h=h*0.65;
	$(".vframe").css({"height":h});
}

function bindTogglePrintPDF()
{	$("body").keydown(function(evt){
			if(evt.which==65)
			{	if(!pdf)
				{	$("head link[href='"+screencss+"']").attr("href", pdfcss);
					$(".vframe").css({"height": "400px"});
				}
				else
				{	$("head link[href='"+pdfcss+"']").attr("href", screencss);
					setVertical();
				}
				pdf=!pdf;
			}
		}
	);
}

//SliNKi Initialisation
function setTitle()
{	title=slinki.title;
	try
	{	if(title==null)
		{	header=$("h1:first");
			if(header==null)
			{	header=$("h2:first");
			}
			if(header==null)
			{	header=$("h3:first");
			}
			if(header==null)
			{	header=$("p:first");
			}
			title="SliNKi : "+header.text();
		}
	}
	catch(e)
	{	title="SliNKi Presentation";
	}
	$("title").html(title);
}
function setCopyright()
{	copyright=slinki.copyright;
	if(copyright!=null)
	{	$("head meta[name='copyright']").attr("content", copyright);
	}
}
function setFavicon()
{	favicon=slinki.favicon;
	if(favicon!=null)
	{	$("#favicon").attr("href", favicon);
	}
	//Force browsers to see that favicon has changed!
	favicon=$("#favicon").detach();
	$("head").append(favicon);
}
function setScripts()
{	if(slinki.scripts!=null)
	{	for(i=0; i<slinki.scripts.length; i++)
		{	s=slinki.scripts[i];
			$("head").append("<script src='"+s+"' type='text/javascript'>_</script>");
		}
	}
}
function setCSS()
{	var css=slinki.css;
	if(css==null)
	{	//Default CSS
		css= [
				{ "href" : "/wink/style/xmlverb.css" }
			];
	}
	for(i=0; i<css.length; i++)
	{	s=css[i];
		href=s.href;
		media=s.media;
		if(media==null)
		{	set=true;
			if(s.screen)
			{	screencss=s.href;
			}
			if(s.pdf)
			{	pdfcss=s.href;
				set=false;
			}
			if(set)
			{	$("head").append("<link href='"+s.href+"' rel='stylesheet' type='text/css' />");
			}
		}
		else
		{	$("head").append("<link href='"+s.href+"' rel='stylesheet' type='text/css' media='"+media+"'/>");
		}
	}
}